<?php
/**
 * UpdateSurveyNodeInputObject
 *
 * PHP version 5
 *
 * @category Class
 * @package  text-magic
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * TextMagic
 *
 * TextMagic REST API
 *
 * OpenAPI spec version: 2
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 2.4.7
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace text-magic\Model;

use \ArrayAccess;
use \text-magic\ObjectSerializer;

/**
 * UpdateSurveyNodeInputObject Class Doc Comment
 *
 * @category Class
 * @package  text-magic
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class UpdateSurveyNodeInputObject implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'updateSurveyNodeInputObject';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'nodeType' => 'string',
        'label' => 'string',
        'isEndNode' => 'bool',
        'body' => 'string',
        'startNode' => 'int',
        'sendDelay' => 'int'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'nodeType' => null,
        'label' => null,
        'isEndNode' => null,
        'body' => null,
        'startNode' => null,
        'sendDelay' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'nodeType' => 'nodeType',
        'label' => 'label',
        'isEndNode' => 'isEndNode',
        'body' => 'body',
        'startNode' => 'startNode',
        'sendDelay' => 'sendDelay'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'nodeType' => 'setNodeType',
        'label' => 'setLabel',
        'isEndNode' => 'setIsEndNode',
        'body' => 'setBody',
        'startNode' => 'setStartNode',
        'sendDelay' => 'setSendDelay'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'nodeType' => 'getNodeType',
        'label' => 'getLabel',
        'isEndNode' => 'getIsEndNode',
        'body' => 'getBody',
        'startNode' => 'getStartNode',
        'sendDelay' => 'getSendDelay'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    const NODE_TYPE_A = 'a';
    const NODE_TYPE_Q = 'q';
    

    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getNodeTypeAllowableValues()
    {
        return [
            self::NODE_TYPE_A,
            self::NODE_TYPE_Q,
        ];
    }
    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['nodeType'] = isset($data['nodeType']) ? $data['nodeType'] : null;
        $this->container['label'] = isset($data['label']) ? $data['label'] : null;
        $this->container['isEndNode'] = isset($data['isEndNode']) ? $data['isEndNode'] : null;
        $this->container['body'] = isset($data['body']) ? $data['body'] : null;
        $this->container['startNode'] = isset($data['startNode']) ? $data['startNode'] : null;
        $this->container['sendDelay'] = isset($data['sendDelay']) ? $data['sendDelay'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        $allowedValues = $this->getNodeTypeAllowableValues();
        if (!is_null($this->container['nodeType']) && !in_array($this->container['nodeType'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value for 'nodeType', must be one of '%s'",
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets nodeType
     *
     * @return string
     */
    public function getNodeType()
    {
        return $this->container['nodeType'];
    }

    /**
     * Sets nodeType
     *
     * @param string $nodeType Node type. \\'a\\' answer; \\'q\\' - question
     *
     * @return $this
     */
    public function setNodeType($nodeType)
    {
        $allowedValues = $this->getNodeTypeAllowableValues();
        if (!is_null($nodeType) && !in_array($nodeType, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value for 'nodeType', must be one of '%s'",
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['nodeType'] = $nodeType;

        return $this;
    }

    /**
     * Gets label
     *
     * @return string
     */
    public function getLabel()
    {
        return $this->container['label'];
    }

    /**
     * Sets label
     *
     * @param string $label Node label
     *
     * @return $this
     */
    public function setLabel($label)
    {
        $this->container['label'] = $label;

        return $this;
    }

    /**
     * Gets isEndNode
     *
     * @return bool
     */
    public function getIsEndNode()
    {
        return $this->container['isEndNode'];
    }

    /**
     * Sets isEndNode
     *
     * @param bool $isEndNode Define node is ending for survey. Default is false
     *
     * @return $this
     */
    public function setIsEndNode($isEndNode)
    {
        $this->container['isEndNode'] = $isEndNode;

        return $this;
    }

    /**
     * Gets body
     *
     * @return string
     */
    public function getBody()
    {
        return $this->container['body'];
    }

    /**
     * Sets body
     *
     * @param string $body Node body
     *
     * @return $this
     */
    public function setBody($body)
    {
        $this->container['body'] = $body;

        return $this;
    }

    /**
     * Gets startNode
     *
     * @return int
     */
    public function getStartNode()
    {
        return $this->container['startNode'];
    }

    /**
     * Sets startNode
     *
     * @param int $startNode Start node id
     *
     * @return $this
     */
    public function setStartNode($startNode)
    {
        $this->container['startNode'] = $startNode;

        return $this;
    }

    /**
     * Gets sendDelay
     *
     * @return int
     */
    public function getSendDelay()
    {
        return $this->container['sendDelay'];
    }

    /**
     * Sets sendDelay
     *
     * @param int $sendDelay Define delay for sending question to recipients after previous answer. Default is 0
     *
     * @return $this
     */
    public function setSendDelay($sendDelay)
    {
        $this->container['sendDelay'] = $sendDelay;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


